/**
  ******************************************************************************
  * File Name          : main.c
  * Description        : Main program body
  ******************************************************************************
  *
  * COPYRIGHT(c) 2016 STMicroelectronics
  *
  * Redistribution and use in source and binary forms, with or without modification,
  * are permitted provided that the following conditions are met:
  *   1. Redistributions of source code must retain the above copyright notice,
  *      this list of conditions and the following disclaimer.
  *   2. Redistributions in binary form must reproduce the above copyright notice,
  *      this list of conditions and the following disclaimer in the documentation
  *      and/or other materials provided with the distribution.
  *   3. Neither the name of STMicroelectronics nor the names of its contributors
  *      may be used to endorse or promote products derived from this software
  *      without specific prior written permission.
  *
  * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
  * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
  * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
  * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE
  * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
  * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
  * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
  * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
  * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
  * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
  *
  ******************************************************************************
  */
/* Includes ------------------------------------------------------------------*/
#include "stm32f2xx_hal.h"
#include "adc.h"
#include "eth.h"
#include "tim.h"
#include "usart.h"
#include "usb_otg.h"
#include "gpio.h"

/* USER CODE BEGIN Includes */
#include "main.h"
#include <stdio.h>
#include <string.h>
#include "frame.h"
#include "panel.h"
#include "hd44780.h"
/* USER CODE END Includes */

/* Private variables ---------------------------------------------------------*/

/* USER CODE BEGIN PV */
/* Private variables ---------------------------------------------------------*/
uint8_t 	ChangeValue;
uint32_t	timeup;
uint32_t	tmr_sec;
uint32_t	tmr_display;

struct sbuffer Buffer;
struct sdisplay displayCursor;
struct smeasure measureData;
struct soutputSettings outputSet;

float fsum = 0;

uint8_t rx_data;
float K = 15;
float T = 0.005;
/* USER CODE END PV */

/* Private function prototypes -----------------------------------------------*/
void SystemClock_Config(void);

/* USER CODE BEGIN PFP */
/* Private function prototypes -----------------------------------------------*/

/* USER CODE END PFP */

/* USER CODE BEGIN 0 */

/* USER CODE END 0 */

int main(void)
{

  /* USER CODE BEGIN 1 */
	fsum = 0;
	tmr_sec = 1000;
	tmr_display = 300;

//---------
	displayCursor.line = 0;
	displayCursor.position = 1;
//---------
    measureData.fvoltage_req = 8.0;
    measureData.fcurrent_req = 0.0;
//---------
    outputSet.enableOutput = 1;
    outputSet.controlMode = 1;
//---------
//BUFFER INIT
	Buffer.index = 0;
	Buffer.save = 0;
	Buffer.flag = 0;

  /* USER CODE END 1 */

  /* MCU Configuration----------------------------------------------------------*/

  /* Reset of all peripherals, Initializes the Flash interface and the Systick. */
  HAL_Init();

  /* Configure the system clock */
  SystemClock_Config();

  /* Initialize all configured peripherals */
  MX_GPIO_Init();
  MX_ADC1_Init();
  MX_TIM1_Init();
  MX_USART1_UART_Init();
  MX_USART2_UART_Init();
  MX_TIM3_Init();

  /* USER CODE BEGIN 2 */

  HAL_UART_Receive_IT(&huart1, (uint8_t *)&rx_data, 1);
  HAL_TIM_PWM_Start(&htim1,TIM_CHANNEL_1);
  HAL_TIMEx_PWMN_Start(&htim1,TIM_CHANNEL_1);
  HAL_ADC_Start_IT(&hadc1);
  HAL_TIM_Base_Start(&htim3);
//  HD44780_Init(16, 2);
//  HD44780_CursorOn();
  /* USER CODE END 2 */

  /* Infinite loop */
  /* USER CODE BEGIN WHILE */
  while (1)
  {
  /* USER CODE END WHILE */

  /* USER CODE BEGIN 3 */
		if ( Buffer.flag == 1 )
		{
		  process_command(&measureData, &outputSet);
		}

		if (ChangeValue != 0)
		{
			change_value(&measureData, &displayCursor, &ChangeValue);
		}
//set output
		HAL_GPIO_WritePin(GPIOE, GPIO_PIN_15, outputSet.enableOutput);

		fflush(stdout);

  }
  /* USER CODE END 3 */

}

/** System Clock Configuration
*/
void SystemClock_Config(void)
{

  RCC_OscInitTypeDef RCC_OscInitStruct;
  RCC_ClkInitTypeDef RCC_ClkInitStruct;

  RCC_OscInitStruct.OscillatorType = RCC_OSCILLATORTYPE_HSI|RCC_OSCILLATORTYPE_HSE;
  RCC_OscInitStruct.HSEState = RCC_HSE_ON;
  RCC_OscInitStruct.HSIState = RCC_HSI_ON;
  RCC_OscInitStruct.HSICalibrationValue = 16;
  RCC_OscInitStruct.PLL.PLLState = RCC_PLL_ON;
  RCC_OscInitStruct.PLL.PLLSource = RCC_PLLSOURCE_HSE;
  RCC_OscInitStruct.PLL.PLLM = 8;
  RCC_OscInitStruct.PLL.PLLN = 240;
  RCC_OscInitStruct.PLL.PLLP = RCC_PLLP_DIV2;
  RCC_OscInitStruct.PLL.PLLQ = 5;
  HAL_RCC_OscConfig(&RCC_OscInitStruct);

  RCC_ClkInitStruct.ClockType = RCC_CLOCKTYPE_HCLK|RCC_CLOCKTYPE_SYSCLK
                              |RCC_CLOCKTYPE_PCLK1|RCC_CLOCKTYPE_PCLK2;
  RCC_ClkInitStruct.SYSCLKSource = RCC_SYSCLKSOURCE_PLLCLK;
  RCC_ClkInitStruct.AHBCLKDivider = RCC_SYSCLK_DIV1;
  RCC_ClkInitStruct.APB1CLKDivider = RCC_HCLK_DIV4;
  RCC_ClkInitStruct.APB2CLKDivider = RCC_HCLK_DIV2;
  HAL_RCC_ClockConfig(&RCC_ClkInitStruct, FLASH_LATENCY_3);

  HAL_RCC_MCOConfig(RCC_MCO1, RCC_MCO1SOURCE_HSI, RCC_MCODIV_1);

  HAL_SYSTICK_Config(HAL_RCC_GetHCLKFreq()/1000);

  HAL_SYSTICK_CLKSourceConfig(SYSTICK_CLKSOURCE_HCLK);

  /* SysTick_IRQn interrupt configuration */
  HAL_NVIC_SetPriority(SysTick_IRQn, 1, 0);
}

/* USER CODE BEGIN 4 */
void HAL_GPIO_EXTI_Callback(uint16_t GPIO_Pin)
{
	switch (GPIO_Pin)
	{
		case CHA_Pin:
			if ( HAL_GPIO_ReadPin(CHA_GPIO_Port, CHB_Pin) ) {
				ChangeValue = DOWN;
			} else {
				ChangeValue = UP;
			}
			break;
		case CHB_Pin:
			if ( HAL_GPIO_ReadPin(CHA_GPIO_Port, CHA_Pin) ) {
				ChangeValue = DOWN;
			} else {
				ChangeValue = UP;
			}
			break;
        case S5_Pin:
            //LEFT
            if ( displayCursor.position > 0 ) {
                displayCursor.position--;
            }
            break;
        case S2_Pin:
            //DOWN
            if ( displayCursor.line ) {
                displayCursor.line = 0;
            } else {
                displayCursor.line = 1;
            }
            break;
        case S3_Pin:
            //RIGHT
            if ( displayCursor.position < 2 ) {
                displayCursor.position++;
            }
            break;
        case S4_Pin:
            //UP
            if ( displayCursor.line ) {
                displayCursor.line = 0;
            } else {
                displayCursor.line = 1;
            }
            break;
/*        case EN_OUT_Pin:
       		outputSet.enableOutput ^= 1;
        	break;
        	*/
	}
}

void HAL_UART_RxCpltCallback(UART_HandleTypeDef *huart)
{
	switch ( rx_data ) {
		case START_FRAME:
			Buffer.save = 1;
			Buffer.index = 0;
			break;
		case END_FRAME:
			Buffer.save = 0;
			Buffer.flag = 1;
			break;
		default:
			if ( Buffer.save && Buffer.index < 100 ) {
				Buffer.data[ Buffer.index ] = rx_data;
				Buffer.index++;
			}
	}

	HAL_UART_Receive_IT(&huart1, (uint8_t *)&rx_data, 1);
}

void HAL_SYSTICK_Callback(void)
{
	if (--tmr_sec == 0)
	{
		tmr_sec = 1000;
		timeup++;
	}
	if (--tmr_display == 0)
	{
		tmr_display = 1000;
		update_lcd(&displayCursor, &measureData);
	}
}

uint16_t ps(float error)
{
	uint16_t reg;

	fsum += error * T;

	if (fsum > MAX_VAL)
		fsum = MAX_VAL;
	else if (fsum < -MAX_VAL)
		fsum = -MAX_VAL;

	reg = (uint16_t)(( fsum + error ) * K);

	if (reg > MAX_VAL)
		reg = MAX_VAL;

	return reg;
}

void HAL_ADC_ConvCpltCallback(ADC_HandleTypeDef* AdcHandle)
{
	uint16_t duty;
	__disable_irq();

	measureData.fvoltage = HAL_ADC_GetValue(AdcHandle) / 111.9029;

	duty = ps(measureData.fvoltage_req - measureData.fvoltage);
	set_duty(duty);

	__enable_irq();
}

void set_duty(uint32_t duty)
{
	htim1.Instance->CCR1 = PERIOD - duty;
}
/* USER CODE END 4 */

#ifdef USE_FULL_ASSERT

/**
   * @brief Reports the name of the source file and the source line number
   * where the assert_param error has occurred.
   * @param file: pointer to the source file name
   * @param line: assert_param error line source number
   * @retval None
   */
void assert_failed(uint8_t* file, uint32_t line)
{
  /* USER CODE BEGIN 6 */
  /* User can add his own implementation to report the file name and line number,
    ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
  /* USER CODE END 6 */

}

#endif

/**
  * @}
  */ 

/**
  * @}
*/ 

/************************ (C) COPYRIGHT STMicroelectronics *****END OF FILE****/
